<?php

###########################################################################
#
#   :
#         LDAP.
#       ,     
#        JSON
#

###########################################################################
#
#      
#   
#              LDAP,
#   .    .
#   
#   :
#   http://127.0.0.1/irbis64r_plus/php/login_by_ldap.php?samaccountname=ivanov&password=123
#        :
#   *   (samaccountname)
$samaccountname = $_GET['samaccountname'];
#   *  (password)
$password = $_GET['password'];

###########################################################################
#
#      LDAP   (  )
#
###########################################################################
#        LDAP -    
#       ,        
#       ,    $ldap_server_count   .
#         $ldap_server_count = 1;
$ldap_server_count = 1;
###########################################################################
#      ,   LDAP.
#       IP   .
$ldap_uri =
   array(
      1 => "ldap://127.0.0.1",
      #2 => "ldap://localhost",
      );
###########################################################################
#          .
#        .     $samaccountname 
#         ,   
#      .
$rdn =
   array(
      1 => "one\\$samaccountname",
      #2 => "two\\$samaccountname",
      );
###########################################################################
#      Base Distinguished Name    ,    
#         .
$base_dn =
   array(
      1 => "dc=one,dc=local",
      #2 => "dc=two,dc=local",
      );
#
#      LDAP   (  )
#
###########################################################################

###########################################################################
#
#       LDAP -    !!!!!!!!
#
###########################################################################
#        LDAP   .
$filter = "(samaccountname=$samaccountname)";

echo "{";
echo '"query_samaccountname": "' . $samaccountname . '",';

$is_success_bind = false;
$error_msg = "";
for ($i = 1; $i <= $ldap_server_count; $i++)
{
   $ldap = @ldap_connect($ldap_uri[$i]);
   ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
   ldap_set_option($ldap, LDAP_OPT_REFERRALS, 0);
   $bind = @ldap_bind($ldap, $rdn[$i], $password);
   if ($bind)
   {
      $result = @ldap_search($ldap, $base_dn[$i], $filter);
      $info = @ldap_get_entries($ldap, $result);
      if($info['count'] == 1)
      {
         echo '"samaccountname": "' . @$info[0]["samaccountname"][0] . '",';
         echo '"sn": "' . @$info[0]["sn"][0] . '",';
         echo '"givenname": "' . @$info[0]["givenname"][0] . '",';
         echo '"mail": "' . @$info[0]["mail"][0] . '",';
         echo '"displayname": "' . @$info[0]["displayname"][0] . '",';
         echo '"department": "' . @$info[0]["department"][0] . '",';
         echo '"title": "' . @$info[0]["title"][0] . '",';
         $is_success_bind = true;
      }
      else
      {
         $error_msg = $error_msg + "   " . "was bind ldap record <> 1";
      }
   }
   else
   {
      ldap_get_option($ldap, LDAP_OPT_DIAGNOSTIC_MESSAGE, $extended_error);
      $error_msg = $error_msg . "   " . $extended_error;
   }
   @ldap_close($ldap);

   if ($is_success_bind)
      break;
}
if (!$is_success_bind)
{
   echo '"extended_error": "' . $error_msg . '",';
}

echo '"nothing": "nothing"';
echo "}";

?>