﻿var webIrbisSettings = 
{
	// максимальное количество документов, выводимых единым списком в графическом интерфейсе Веб-ИРБИС
	"max_list_document_count" : 100,
	// разрешить кеш изображений страниц (true), или запретить (false)
	"page_image_cache_allow" : true,
   // Принимает одно из значений 0, 1, 2:
   // 0 - смена страниц колесом мыши запрещена;
   // 1 - смена страниц колесом мыши работает в одностраничном режиме;
   // 2 - смена страниц колесом мыши работает также и в двухстраничном режиме
   "wheelPageChangerSetting" : 1,
   // Количество изображений страниц в просмотрщике полного текста
   // в исходном состоянии при его запуске.
   // Допустимые значения: 1 или 2.
   "initializationPagePortionCount" : 2,
   
   //////////////////////////////////////////////////////////////////////////////////////
   //   НАСТРОЙКИ АУТЕНТИФИКАЦИИ ЧЕРЕЗ LDAP
   //////////////////////////////////////////////////////////////////////////////////////
   // Включен ли вход с аутентификацией через LDAP (да - true, нет - false)
   "isLdapLoggingOn" : false,
   // Доступна ли в GUI возможность переключения между обычным входом в ИРБИС и через LDAP (да - true, нет - false)
   "isLdapToggleVisible" : true,
   // Список меток LDAP, значения которых будут записаны в соответствующие поля записи базы RDR ИРБИС
   // при регистрации читателя через LDAP (данный список позволяет ограничить набор принимаемых полей)
   "irbis_tag_list" : ["30", "10", "11", "12", "32", "33"],
   // Задать соответствие меток записи базы RDR ИРБИС полям записи LDAP
   "ldap_tag_by_irbis" :
   {
      "30" : "samaccountname",
      "32" : "mail",
      // выражение с индексом в квадратных скобках обозначает взятие слова с указанным номером (displayname представляет собой ФИО разделенные пробелами)
      "10" : "displayname[2]",
      "11" : "displayname[0]",
      "12" : "displayname[1]"
   },
   // В случае записи через LDAP аутентификацию записать определенные значения в поля базы RDR с заданными метками
   "rdr_default_value" :
   {
      "33" : "Запись через LDAP"
   },
   //////////////////////////////////////////////////////////////////////////////////////
   //   НАСТРОЙКИ АУТЕНТИФИКАЦИИ ЧЕРЕЗ LDAP (конец блока)
   //////////////////////////////////////////////////////////////////////////////////////
   //
	"end" : undefined
};